#include<cstdio>
#include<iostream>
#include<algorithm>
#include<vector>
#include<ctime>
using namespace std;

const int N_FORMULAS=3;
const float TIME_LIMIT=1.98;
const int MAX_N=50;
const int MAX_M=50;
const int MAX_P=100;

struct animal
{
	int form[10][10];
	int r, c, k, t;
	double val[N_FORMULAS];
	int number;
	int area;
} animals[MAX_P];

struct jump
{
	int number, row, column;
	int safety;
};

vector<jump> v[N_FORMULAS];
int total_safety[N_FORMULAS];
vector<jump> best;
int best_safety=0;
int current_safety;

int n, m, p, b;
int field[MAX_N+1][MAX_M+1];
int original_field[MAX_N+1][MAX_M+1];
int temp_field[MAX_N+1][MAX_M+1];
int temp_field1[MAX_N+1][MAX_M+1];

clock_t t1,t2;
float runtime=0;

bool operator<(const animal &x, const animal &y)
{
	if(x.val[0]!=y.val[0])
		return x.val[0]>y.val[0];
	else
		return x.number>y.number;
}
bool cmp1(const animal &x, const animal &y)
{
	if(x.val[1]!=y.val[1])
		return x.val[1]>y.val[1];
	else
		return x.number>y.number;
}
bool cmp2(const animal &x, const animal &y)
{
	if(x.val[2]!=y.val[2])
		return x.val[2]>y.val[2];
	else
		return x.number>y.number;
}
bool cmpnum(const animal &x, const animal &y)
{
	return x.number<y.number;
}


void input()
{
	char c;

	scanf("%d%d%d", &n, &m, &p);

	for(int i=1; i<=n; i++)
		for(int j=1; j<=m; j++)
			scanf("%d", &original_field[i][j]);

	for(int x=0; x<p; x++)
	{
		scanf("%d%d%d%d", &animals[x].r, &animals[x].c, &animals[x].k, &animals[x].t);
		animals[x].number=x+1;

		animals[x].area=0;
		for(int i=0; i<animals[x].r; i++)
			for(int j=0; j<animals[x].c; j++)
			{
				cin>>c;
				if(c=='1')
					animals[x].form[i][j]=1;
				else if(c=='0')
					animals[x].form[i][j]=0;
				animals[x].area+=animals[x].form[i][j];
			}
		animals[x].val[0]=(double)(animals[x].area)/(animals[x].k); // formula 0
		animals[x].val[1]=(double)(animals[x].area*animals[x].area+animals[x].r+animals[x].c)/(animals[x].k); // Formula 1 :)
		animals[x].val[2]=(double)(animals[x].area)/(animals[x].k*animals[x].k); // formula 2
	}
}

void output()
{
	//printf("%d\n", best_safety);
	printf("%d\n", best.size());
	for(int i=0; i<best.size(); i++)
		printf("%d %d %d\n", best[i].number, best[i].row, best[i].column);

	t2=clock();
	runtime = ((float)t2-(float)t1)/CLOCKS_PER_SEC;
	//printf("%f\n", runtime);

}

void timecheck()
{
	t2=clock();
	runtime = ((float)t2-(float)t1)/CLOCKS_PER_SEC;
	if(runtime>=TIME_LIMIT)
	{
		output();
		exit(0);
	}
}

int jump_xth(int x, int f)
{
	int temp_safety=0, max_safety=0, maxi=-1, maxj=-1;
	bool unsafe=0;

	timecheck();

	for(int i=1; i<=n-animals[x].r+1; i++)
		for(int j=1; j<=m-animals[x].c+1; j++)
			{
				temp_safety=0;
				unsafe=0;
				for(int k=0; k<animals[x].r; k++)
				{
					for(int l=0; l<animals[x].c; l++)
						if(animals[x].form[k][l]==1 && animals[x].t>field[i+k][j+l])
						{
							unsafe=1;
							break;
						}
						else
							temp_safety+=field[i+k][j+l]*animals[x].form[k][l];
					if(unsafe)
					{
						temp_safety=0;
						break;
					}
				}
				if(temp_safety>max_safety)
				{
					max_safety=temp_safety;
					maxi=i;
					maxj=j;
				}
			}

	if(max_safety>0)
	{
		for(int i=0; i<animals[x].r; i++)
			for(int j=0; j<animals[x].c; j++)
				if(animals[x].form[i][j])
					field[maxi+i][maxj+j]/=animals[x].k;
		jump y;
		y.number=animals[x].number;
		y.row=maxi;
		y.column=maxj;
		y.safety=max_safety;
		v[f].push_back(y);
	}
	return max_safety;
}

void find_base_solution(int pos)
{
	for(int i=0; i<N_FORMULAS; i++)
		v[i].clear();
	for(int f=0; f<N_FORMULAS; f++)
		total_safety[f]=0;
	int best_f=0;


	for(int i=1; i<=n; i++)
		for(int j=1; j<=m; j++)
			field[i][j]=original_field[i][j];
	sort(animals+pos, animals+p);
	for(int x=0; x<p; x++)
	{
		jump_xth(x,0);
	}
	for(int i=0; i<v[0].size(); i++)
		total_safety[0]+=v[0][i].safety;


	for(int i=1; i<=n; i++)
		for(int j=1; j<=m; j++)
			field[i][j]=original_field[i][j];
	sort(animals+pos, animals+p, cmp1);
	for(int x=0; x<p; x++)
	{
		jump_xth(x,1);
	}
	for(int i=0; i<v[1].size(); i++)
		total_safety[1]+=v[1][i].safety;


	for(int i=1; i<=n; i++)
		for(int j=1; j<=m; j++)
			field[i][j]=original_field[i][j];
	sort(animals+pos, animals+p, cmp2);
	for(int x=0; x<p; x++)
	{
		jump_xth(x,2);
	}
	for(int i=0; i<v[2].size(); i++)
		total_safety[2]+=v[2][i].safety;


	for(int f=0; f<N_FORMULAS; f++)
		if(total_safety[f]>total_safety[best_f])
			best_f=f;
	if(total_safety[best_f]>best_safety)
	{
		best_safety=total_safety[best_f];
		best.clear();
		for(int i=0; i<v[best_f].size(); i++)
			best.push_back(v[best_f][i]);
	}
}

void vary_first_position()
{
	int x=0;
	int jump_safety=0;
	bool unsafe=0;
	for(int i=1; i<=n-animals[x].r+1; i++)
		for(int j=1; j<=m-animals[x].c+1; j++)
		{
			timecheck();

			for(int i=1; i<=n; i++)
				for(int j=1; j<=m; j++)
					field[i][j]=original_field[i][j];

			v[0].clear();
			jump_safety=0;
			unsafe=0;
			for(int k=0; k<animals[x].r; k++)
			{
				for(int l=0; l<animals[x].c; l++)
					if(animals[x].form[k][l]==1 && animals[x].t>field[i+k][j+l])
					{
						unsafe=1;
						break;
					}
					else
						jump_safety+=field[i+k][j+l]*animals[x].form[k][l];
				if(unsafe)
				{
					jump_safety=0;
					break;
				}
			}

			if(!unsafe)
			{
				for(int k=0; k<animals[x].r; k++)
					for(int l=0; l<animals[x].c; l++)
						if(animals[x].form[k][l]==1)
							field[i+k][j+l]/=animals[x].k;
			}
			else
				continue;

			for(int x=1; x<p; x++)
			{
				jump_xth(x,0);
			}

			current_safety=jump_safety;
			for(int i=0; i<v[0].size(); i++)
				current_safety+=v[0][i].safety;
			if(current_safety>best_safety)
			{
				best_safety=current_safety;
				best.clear();
				jump y;
				y.number=animals[x].number;
				y.row=i;
				y.column=j;
				y.safety=jump_safety;
				best.push_back(y);
				for(int i=0; i<v[0].size(); i++)
					best.push_back(v[0][i]);
			}
		}
}

void vary_first_three_positions()
{
	int x=0;
	int x1=1;
	int x2=2;
	int jump_safety=0;
	bool unsafe=0;
	for(int i=1; i<=n-animals[x].r+1; i++)
		for(int j=1; j<=m-animals[x].c+1; j++)
		{
			timecheck();

			for(int i=1; i<=n; i++)
				for(int j=1; j<=m; j++)
					temp_field[i][j]=original_field[i][j];

			v[0].clear();
			jump_safety=0;
			unsafe=0;
			for(int k=0; k<animals[x].r; k++)
			{
				for(int l=0; l<animals[x].c; l++)
					if(animals[x].form[k][l]==1 && animals[x].t>temp_field[i+k][j+l])
					{
						unsafe=1;
						break;
					}
					else
						jump_safety+=temp_field[i+k][j+l]*animals[x].form[k][l];
				if(unsafe)
				{
					jump_safety=0;
					break;
				}
			}

			if(!unsafe)
			{
				for(int k=0; k<animals[x].r; k++)
					for(int l=0; l<animals[x].c; l++)
						if(animals[x].form[k][l]==1)
							temp_field[i+k][j+l]/=animals[x].k;
			}
			else
				continue;

			int jump_safety1=0;
			bool unsafe1=0;
			for(int i1=1; i1<=n-animals[x1].r+1; i1++)
				for(int j1=1; j1<=m-animals[x1].c+1; j1++)
				{
					timecheck();

					for(int i=1; i<=n; i++)
						for(int j=1; j<=m; j++)
							temp_field1[i][j]=temp_field[i][j];

					v[0].clear();
					jump_safety1=0;
					unsafe1=0;
					for(int k1=0; k1<animals[x1].r; k1++)
					{
						for(int l1=0; l1<animals[x1].c; l1++)
							if(animals[x1].form[k1][l1]==1 && animals[x1].t>temp_field1[i1+k1][j1+l1])
							{
								unsafe1=1;
								break;
							}
							else
								jump_safety1+=temp_field1[i1+k1][j1+l1]*animals[x1].form[k1][l1];
						if(unsafe1)
						{
							jump_safety1=0;
							break;
						}
					} // end for k1

					if(!unsafe1)
					{
						for(int k1=0; k1<animals[x1].r; k1++)
							for(int l1=0; l1<animals[x1].c; l1++)
								if(animals[x1].form[k1][l1]==1)
									temp_field1[i1+k1][j1+l1]/=animals[x1].k;
					}
					else
						continue;
					int jump_safety2=0;
					bool unsafe2=0;
					for(int i2=1; i2<=n-animals[x2].r+1; i2++)
						for(int j2=1; j2<=m-animals[x2].c+1; j2++)
						{
							timecheck();

							for(int i=1; i<=n; i++)
								for(int j=1; j<=m; j++)
									field[i][j]=temp_field1[i][j];

							v[0].clear();
							jump_safety2=0;
							unsafe2=0;
							for(int k2=0; k2<animals[x2].r; k2++)
							{
								for(int l2=0; l2<animals[x2].c; l2++)
									if(animals[x2].form[k2][l2]==1 && animals[x2].t>field[i2+k2][j2+l2])
									{
										unsafe2=1;
										break;
									}
									else
										jump_safety2+=field[i2+k2][j2+l2]*animals[x2].form[k2][l2];
								if(unsafe2)
								{
									jump_safety2=0;
									break;
								}
							} // end for k2

							if(!unsafe2)
							{
								for(int k2=0; k2<animals[x2].r; k2++)
									for(int l2=0; l2<animals[x2].c; l2++)
										if(animals[x2].form[k2][l2]==1)
											field[i2+k2][j2+l2]/=animals[x2].k;
							}
							else
								continue;

							for(int x=3; x<p; x++)
							{
								jump_xth(x,0);
							}

							current_safety=jump_safety+jump_safety1+jump_safety2;
							for(int i=0; i<v[0].size(); i++)
								current_safety+=v[0][i].safety;

							if(current_safety>best_safety)
							{
								best_safety=current_safety;
								best.clear();
								jump y;
								y.number=animals[x].number;
								y.row=i;
								y.column=j;
								y.safety=jump_safety;
								best.push_back(y);
								y.number=animals[x1].number;
								y.row=i1;
								y.column=j1;
								y.safety=jump_safety1;
								best.push_back(y);
								y.number=animals[x2].number;
								y.row=i2;
								y.column=j2;
								y.safety=jump_safety2;
								best.push_back(y);
								for(int i=0; i<v[0].size(); i++)
									best.push_back(v[0][i]);
							}
						} // end for j2
				} // end for j1
		} // end for j
}

void vary_first_two_positions()
{
	int x=0;
	int x1=1;
	int jump_safety=0;
	bool unsafe=0;
	for(int i=1; i<=n-animals[x].r+1; i++)
		for(int j=1; j<=m-animals[x].c+1; j++)
		{
			timecheck();

			for(int i=1; i<=n; i++)
				for(int j=1; j<=m; j++)
					temp_field[i][j]=original_field[i][j];

			v[0].clear();
			jump_safety=0;
			unsafe=0;
			for(int k=0; k<animals[x].r; k++)
			{
				for(int l=0; l<animals[x].c; l++)
					if(animals[x].form[k][l]==1 && animals[x].t>temp_field[i+k][j+l])
					{
						unsafe=1;
						break;
					}
					else
						jump_safety+=temp_field[i+k][j+l]*animals[x].form[k][l];
				if(unsafe)
				{
					jump_safety=0;
					break;
				}
			}

			if(!unsafe)
			{
				for(int k=0; k<animals[x].r; k++)
					for(int l=0; l<animals[x].c; l++)
						if(animals[x].form[k][l]==1)
							temp_field[i+k][j+l]/=animals[x].k;
			}
			else
				continue;

			int jump_safety1=0;
			bool unsafe1=0;
			for(int i1=1; i1<=n-animals[x1].r+1; i1++)
				for(int j1=1; j1<=m-animals[x1].c+1; j1++)
				{
					timecheck();

					for(int i=1; i<=n; i++)
						for(int j=1; j<=m; j++)
							field[i][j]=temp_field[i][j];

					v[0].clear();
					jump_safety1=0;
					unsafe1=0;
					for(int k1=0; k1<animals[x1].r; k1++)
					{
						for(int l1=0; l1<animals[x1].c; l1++)
							if(animals[x1].form[k1][l1]==1 && animals[x1].t>field[i1+k1][j1+l1])
							{
								unsafe1=1;
								break;
							}
							else
								jump_safety1+=field[i1+k1][j1+l1]*animals[x1].form[k1][l1];
						if(unsafe1)
						{
							jump_safety1=0;
							break;
						}
					} // end for k1

					if(!unsafe1)
					{
						for(int k1=0; k1<animals[x1].r; k1++)
							for(int l1=0; l1<animals[x1].c; l1++)
								if(animals[x1].form[k1][l1]==1)
									field[i1+k1][j1+l1]/=animals[x1].k;
					}
					else
						continue;

					for(int x=2; x<p; x++)
					{
						jump_xth(x,0);
					}

					current_safety=jump_safety+jump_safety1;
					for(int i=0; i<v[0].size(); i++)
						current_safety+=v[0][i].safety;

					if(current_safety>best_safety)
					{
						best_safety=current_safety;
						best.clear();
						jump y;
						y.number=animals[x].number;
						y.row=i;
						y.column=j;
						y.safety=jump_safety;
						best.push_back(y);
						y.number=animals[x1].number;
						y.row=i1;
						y.column=j1;
						y.safety=jump_safety1;
						best.push_back(y);
						for(int i=0; i<v[0].size(); i++)
							best.push_back(v[0][i]);
					}

				} // end for j1
		} // end for j
}

void vary_first_animal()
{
	for(int x=0; x<p; x++)
	{
		sort(animals, animals+p, cmpnum);
		swap(animals[0], animals[x]);
		find_base_solution(1);
	}
}

void big_animal();

void medium_animal()
{
	vary_first_animal();

	sort(animals, animals+p, cmp1);
	vary_first_position();

	sort(animals, animals+p);
	vary_first_position();

	sort(animals, animals+p, cmp2);
	vary_first_position();

	sort(animals, animals+p, cmp1);
	vary_first_three_positions();

	sort(animals, animals+p);
	vary_first_three_positions();

	sort(animals, animals+p, cmp2);
	vary_first_three_positions();

	big_animal();
}

void small_animal()
{
	for(int x=0; x<p; x++)
	{

		for(int x1=0; x1<p; x1++)
		{
			if(x==x1)
				continue;
			sort(animals, animals+p, cmpnum);
			if(x1==0)
			{
				swap(animals[0], animals[1]);
				if(x!=1)
				swap(animals[0], animals[x]);
			}
			else
			{
				swap(animals[0], animals[x]);
				swap(animals[1], animals[x1]);
			}
			sort(animals+2, animals+p, cmp1);
			vary_first_two_positions();
			sort(animals+2, animals+p);
			vary_first_two_positions();
			sort(animals+2, animals+p, cmp2);
			vary_first_two_positions();
		}
	}
	sort(animals+2, animals+p, cmp1);
	vary_first_three_positions();
	sort(animals+2, animals+p);
	vary_first_three_positions();
	sort(animals+2, animals+p, cmp2);
	vary_first_three_positions();


	medium_animal();
}

void big_animal()
{
	for(int x=0; x<p; x++)
		if(animals[x].area>75 && animals[x].area/(animals[x].r*animals[x].c)>0,95)
			{
				animals[x].val[0]*=animals[x].area;
				animals[x].val[1]*=animals[x].area;
				animals[x].val[2]*=animals[x].area;
			}
	vary_first_animal();

	sort(animals, animals+p, cmp1);
	vary_first_two_positions();

	sort(animals, animals+p);
	vary_first_two_positions();

	sort(animals, animals+p, cmp2);
	vary_first_two_positions();

	sort(animals, animals+p, cmp1);
	vary_first_position();

	sort(animals, animals+p);
	vary_first_position();

	sort(animals, animals+p, cmp2);
	vary_first_position();
}

int main()
{
    t1=clock();

	freopen("parash.in", "r", stdin);
	freopen("parash.out", "w", stdout);

	input();
	find_base_solution(0);

	if(p<=8 && m*n<=50)
		small_animal();
	if(p<=50)
		medium_animal();
	else
		big_animal();

	output();

	return 0;
}




